const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const service_suitability_rules = sequelize.define(
    'service_suitability_rules',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

recommended_signature_level: {
        type: DataTypes.ENUM,
      
      

        values: [

"simple",


"advanced",


"notary_required"

        ],

      },

enforcement: {
        type: DataTypes.ENUM,
      
      

        values: [

"warn",


"block"

        ],

      },

condition_text: {
        type: DataTypes.TEXT,
      
      

      },

message: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  service_suitability_rules.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.service_suitability_rules.belongsTo(db.document_types, {
      as: 'document_type',
      foreignKey: {
        name: 'document_typeId',
      },
      constraints: false,
    });

    db.service_suitability_rules.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.service_suitability_rules.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.service_suitability_rules.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return service_suitability_rules;
};


